Merge remote-tracking branch 'origin/pr/118'
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -E
35    set -o pipefail
36    trap "error_handler" ERR
37    export -f "error_handler"
38 fi
39 # }}}
40
41 # variables {{{
42 PN="$(basename "$0")"
43 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
44   VERSION="$(git describe | sed 's|^v||')"
45 else
46   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
47 fi
48 VERSION="${VERSION:-unknown}"
49 MNTPOINT="/mnt/debootstrap.$$"
50
51 # defaults
52 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
53 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
54 [ -n "$DEBCONF" ] || DEBCONF='yes'
55 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
56 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
57 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
58 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
59 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
60 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
61 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
62 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
63 [ -n "$FORCE" ] || FORCE=''
64 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
65 [ -n "$INITRD" ] || INITRD='yes'
66 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
67 [ -n "$LOCALES" ] || LOCALES='yes'
68 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
69 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
70 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
71 [ -n "$PACKAGES" ] || PACKAGES='yes'
72 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
73 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
74 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
75 [ -n "$RELEASE" ] || RELEASE='buster'
76 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
77 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
78 [ -n "$SECURE" ] || SECURE='yes'
79 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
80 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
81 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
82 [ -n "$VMSIZE" ] || VMSIZE="2G"
83 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
84
85 # inside the chroot system locales might not be available, so use minimum:
86 export LANG=C
87 export LC_ALL=C
88 export LANGUAGE=C
89
90 # make sure interactive mode is only executed when
91 # using an empty configuration file or option --interactive
92 INTERACTIVE=''
93 # }}}
94
95 # help text {{{
96 usage() {
97   echo "$PN - wrapper around debootstrap for installing Debian
98
99 Usage: $PN [options]
100
101 Bootstrap options:
102
103   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
104   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
105                          instead of fetching packages from a mirror.
106   -r, --release <name>   Release of new Debian system (default: buster).
107   -t, --target <target>  Target partition (/dev/...) or directory where the
108                          system should be installed to.
109   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
110                          has no effect if -t is given and represents a directory.
111       --debopt <params>  Extra parameters passed to the debootstrap command.
112       --interactive      Use interactive mode (frontend).
113       --nodebootstrap    Skip debootstrap, only do configuration to the target.
114       --grub <device>    Target for grub installation. Usage example: /dev/sda
115       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
116       --arch <arch>      Set target architecture, use for installing i386 on amd64.
117       --filesystem <fs>  Filesystem that should be used when target is a partition
118                          or Virtual Machine (see --vmfile).
119       --force            Do not prompt for user acknowledgement.
120
121 Options for Virtual Machine deployment:
122
123       --vm               Set up a Virtual Machine on an existing block device
124                          instead of plainly installing to a partition or
125                          directory. Needs to be combined with --target.
126                          Example: --vm --target /dev/mapper/your-vm-disk
127       --vmfile           Like --vm, but install into a regular file (created by
128                          'qemu-img create -f raw ...') instead.
129                          Example: --vmfile --target /mnt/sda1/qemu.img
130       --vmsize <size>    Use specified size for size of VM file (default: 2G).
131                          Syntax as supported by qemu-img, like: --vmsize 3G
132
133 Configuration options:
134
135   -c, --config <file>      Use specified configuration file, defaults to
136                              /etc/debootstrap/config
137   -d, --confdir <path>     Place of config files for debootstrap, defaults
138                              to /etc/debootstrap
139       --packages <file>    Install packages defined in specified list file
140                              instead of using /etc/debootstrap/packages.
141       --nopackages         Skip installation of packages defined in
142                              /etc/debootstrap/packages
143       --nokernel           Skip installation of default kernel images.
144       --nointerfaces       Do not copy /etc/network/interfaces from host system
145                            to target system.
146                            (This option is automatically enabled when using --vmfile.)
147       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
148                            DHCP for eth0) instead of taking over config from host system.
149       --debconf <file>     Pre-seed packages using specified pre-seed db file.
150       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
151       --backportrepos      Enable Debian's backports repository (backports.debian.org).
152       --keep_src_list      Do not overwrite user provided apt sources.list.
153       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
154       --non-free           Enable non-free in COMPONENTS (defaults to 'main' only).
155       --hostname <name>    Hostname of Debian system.
156       --nopassword         Do not prompt for the root password.
157       --password <pwd>     Use specified password as password for user root.
158       --bootappend <line>  Add specified appendline to kernel whilst booting.
159       --chroot-scripts <d> Execute chroot scripts from specified directory.
160       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
161       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
162       --remove-configs     Delete grml-debootstrap configuration files from installed system.
163
164 Other options:
165
166   -v, --verbose            Increase verbosity.
167       --debug              Execute in very verbose way.
168   -h, --help               Print this usage information and exit.
169   -V, --version            Show summary of options and exit.
170
171 Usage examples can be found in the grml-debootstrap manpage.
172 Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
173 "
174 }
175
176 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
177    usage
178    echo 'Please notice that this script requires root permissions!'
179    exit 0
180 fi
181 # }}}
182
183 # early helper functions {{{
184 GOOD='\e[32;01m'
185 BAD='\e[31;01m'
186 WARN='\e[33;01m'
187 NORMAL='\e[0m'
188
189 einfo() {
190   einfon "$1\\n"
191   return 0
192 }
193
194 einfon() {
195   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
196   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
197   LAST_E_CMD=einfon
198   return 0
199 }
200
201 ewarn() {
202   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
203   return 0
204 }
205
206 eerror() {
207   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
208   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
209   LAST_E_CMD=eerror
210   return 0
211 }
212
213 eend() {
214   local retval="${1:-0}"
215   shift
216   if [ "$retval" -gt 0 ]; then
217     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
218   fi
219   return "$retval"
220 }
221
222 check4root(){
223   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
224     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
225   fi
226 }
227
228 check4progs(){
229   local RC=''
230   for arg in "$@" ; do
231     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
232   done
233   if [ -n "$RC" ] ; then
234      echo "$RC not installed"
235      return 1
236   fi
237 }
238 # }}}
239
240 # helper functions {{{
241 cleanup() {
242   if [ -n "$CHROOT_VARIABLES" ] ; then
243     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
244   fi
245
246   if [ -n "$STAGES" ] ; then
247     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
248   fi
249
250   # Remove temporary mountpoint again
251   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
252     rmdir "$MNTPOINT" 2>/dev/null
253   fi
254
255   # make sure $TARGET is not mounted when exiting grml-debootstrap
256   if [ -n "$MNTPOINT" ] ; then
257     if grep -q "$MNTPOINT" /proc/mounts ; then
258       # make sure nothing is left inside chroot so we can unmount it
259       for service in ssh mdadm ; do
260         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
261           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
262         fi
263       done
264
265       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
266
267       # ugly, but make sure we really don't leave anything (/proc /proc and
268       # /dev /dev are intended, trying to work around timing issues, see #657023)
269       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
270         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
271         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
272       done
273
274       if [ -n "$ISODIR" ] ; then
275         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
276       fi
277
278       if [ -n "$DIRECTORY" ] ; then
279         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
280       else
281         einfo "Unmounting $MNTPOINT"
282         umount "$MNTPOINT"
283         eend $?
284       fi
285
286       if [ -n "$STAGES" ] ; then
287         echo -n "Removing stages directory ${STAGES}: "
288         rm -rf "$STAGES" && echo 'done'
289       fi
290
291       # remove directory only if we used the default with process id inside the name
292       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
293         einfo "Removing directory ${MNTPOINT}"
294         rmdir "$MNTPOINT"
295         eend $?
296       fi
297     fi
298   fi
299
300   if [ -n "${ORIG_TARGET}" ] ; then
301     einfo "Removing loopback mount of file ${ORIG_TARGET}."
302     kpartx -d "${ORIG_TARGET}"
303     # Workaround for a bug in kpartx which doesn't clean up properly,
304     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
305     if dmsetup ls | grep -q "^${LOOP_PART} "; then
306       kpartx -d "/dev/${LOOP_DISK}" >/dev/null
307     fi
308     eend $?
309   fi
310 }
311
312 # we want to exit smoothly and clean:
313 bailout(){
314
315   cleanup
316
317   [ -n "$1" ] && EXIT="$1" || EXIT="1"
318   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
319
320   exit "$EXIT"
321 }
322 trap bailout HUP INT QUIT TERM
323
324 # we want to execute all the functions only once, simple check for it:
325 stage() {
326   if [ -n "$2" ] ; then
327      echo "$2" > "${STAGES}/${1}"
328      return 0
329   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
330      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
331      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
332      return 1
333   fi
334 }
335 # }}}
336
337 # make sure we have what we need {{{
338 check4progs debootstrap || bailout 1
339 # }}}
340
341 # source main configuration file {{{
342 if [ -r /etc/debootstrap/config ] ; then
343   # shellcheck disable=SC1091
344   . /etc/debootstrap/config
345 fi
346 # }}}
347
348 # cmdline handling {{{
349 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs
350
351 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
352   $CMDLINE_OPTS -- "$@")
353
354 if [ $? != 0 ]; then
355   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
356 fi
357 eval set -- "$_opt_temp"
358
359 while :; do
360   case "$1" in
361
362   # == Bootstrap options
363   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
364     shift; _opt_mirror="$1"
365     ;;
366   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
367     shift; _opt_iso="$1"
368     ;;
369   --release|-r)        # Release of new Debian system
370     shift; _opt_release="$1"
371     ;;
372   --target|-t)         # Target partition (/dev/...) or directory
373     shift; _opt_target="$1"
374     ;;
375   --vm)                # Virtual machine image (no file)
376     _opt_vm="T"
377     ;;
378   --vmfile)            # Virtual machine file
379     _opt_vmfile="T"
380     ;;
381   --vmsize)            # size of Virtual machine file
382     shift; _opt_vmsize="$1"
383     ;;
384   --mntpoint|-p)       # Mountpoint used for mounting the target system
385     shift; _opt_mntpoint="$1"
386     ;;
387   --debopt)            # Extra parameters passed to the debootstrap command
388     shift; _opt_debopt="$1"
389     ;;
390   --filesystem)        # Filesystem that should be used
391     shift; _opt_filesystem="$1"
392     ;;
393   --interactive)       # Use interactive mode (frontend)
394     _opt_interactive=T
395     ;;
396   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
397     _opt_nodebootstrap=T
398     ;;
399   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
400     _opt_nopackages=T
401     ;;
402   --arch)              # Target architecutre
403     shift; _opt_arch="$1"
404     ;;
405   # just for backwards compatibility
406   --insecure)
407     _opt_insecure=T
408     ;;
409   #
410
411   # == Configuration options
412   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
413     shift; _opt_config="$1"
414     ;;
415   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
416     shift; _opt_confdir="$1"
417     ;;
418   --packages)          # Install packages defined in specified file
419     shift; _opt_packages="$1"
420     _opt_packages_set=T
421     ;;
422   --debconf)           # Pre-seed packages using specified file
423     shift; _opt_debconf="$1"
424     _opt_debconf_set=T
425     ;;
426   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
427     shift; _opt_pre_scripts="$1"
428     _opt_pre_scripts_set=T
429     ;;
430   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
431     shift; _opt_scripts="$1"
432     _opt_scripts_set=T
433     ;;
434   --post-scripts)       # Execute scripts from specified directory
435     shift; _opt_post_scripts="$1"
436     _opt_post_scripts_set=T
437     ;;
438   --chroot-scripts)   # Execute chroot scripts from specified directory
439     shift; _opt_chroot_scripts="$1"
440     _opt_chroot_scripts_set=T
441     ;;
442   --keep_src_list)     # Do not overwrite user provided apt sources.list
443     _opt_keep_src_list=T
444     ;;
445   --hostname)          # Hostname of Debian system
446     shift; _opt_hostname="$1"
447     ;;
448   --password)          # Use specified password as password for user root
449     shift; _opt_password="$1"
450     ;;
451   --defaultinterfaces) # Install default /etc/network/interfaces
452     _opt_defaultinterfaces=T
453     ;;
454   --nointerfaces)      # Skip installation of /etc/network/interfaces
455     _opt_nointerfaces=T
456     ;;
457   --nokernel)          # Skip installation of default kernel images
458     _opt_nokernel=T
459     ;;
460   --nopassword)        # Skip password dialog
461     _opt_nopassword=T
462     ;;
463   --grmlrepos)         # Enable Grml repository
464     _opt_grmlrepos=T
465     ;;
466   --backportrepos)     # Enable Debian backports repository
467     _opt_backportrepos=T
468     ;;
469   --bootappend)        # Add specified appendline to kernel whilst booting
470     shift; _opt_bootappend="$1"
471     ;;
472   --grub)              # Target for grub installation. Use grub syntax for specifying
473     shift; _opt_grub="$1"
474     ;;
475   --efi)               # Target for EFI boot installation
476     shift; _opt_efi="$1"
477     ;;
478   --contrib)           # Add 'contrib' to list of components
479     _opt_contrib=T
480     ;;
481   --non-free)          # Add 'non-free' to list of components
482     _opt_non_free=T
483     ;;
484   --remove-configs)    # Drop config files from installed system
485     _opt_remove_configs=T
486     ;;
487
488   # == Other options
489   --verbose|-v)        # Increase verbosity
490     if [ "$_opt_verbose" ]; then
491       _opt_verbose=$( _opt_verbose + 1 )
492     else
493       _opt_verbose=1
494     fi
495     ;;
496   --debug)             # Execute in debug mode
497     _opt_debug=T
498     ;;
499   --help|-h)           # Print usage information and exit
500     _opt_help=T
501     ;;
502   --version|-V)        # Show version information and exit
503     _opt_version=T
504     ;;
505   --force)             # Do not prompt for user input
506     _opt_force=T
507     ;;
508   --)
509     shift; break
510     ;;
511   *)
512     eerror "Internal getopt error!"; eend 1 ; exit 1
513     ;;
514   esac
515   shift
516 done
517
518 # == business-logic of command line parameter-processing
519
520 # source configuration file in <confdir> if supplied. {{{
521 [ "$_opt_confdir" ] && {
522   CONFFILES=$_opt_confdir
523   einfo "Using config files under $CONFFILES/."
524   if ! [ -r "$CONFFILES/config" ] ; then
525     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
526   fi
527   # shellcheck disable=SC1091 source=config
528   if ! . "$CONFFILES/config" ; then
529     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
530   fi
531   # restore the command line parameter value
532   CONFFILES=$_opt_confdir
533 }
534 # }}}
535
536 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
537 [ "$_opt_iso" ]                 && ISO=$_opt_iso
538 [ "$_opt_release" ]             && RELEASE=$_opt_release
539 [ "$_opt_target" ]              && TARGET=$_opt_target
540 [ "$_opt_vm" ]                  && VIRTUAL=1
541 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
542 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
543 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
544 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
545 [ "$_opt_interactive" ]         && INTERACTIVE=1
546 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
547 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
548 [ "$_opt_packages_set" ]        && PACKAGES='yes'
549 [ "$_opt_nopackages" ]          && PACKAGES=''
550 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
551 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
552 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
553 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
554 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
555 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
556 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
557 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
558 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
559 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
560 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
561 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
562 [ "$_opt_nokernel" ]            && NOKERNEL="true"
563 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
564 [ "$_opt_grub" ]                && GRUB=$_opt_grub
565 [ "$_opt_efi" ]                 && EFI=$_opt_efi
566 [ "$_opt_arch" ]                && ARCH=$_opt_arch
567 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
568 [ "$_opt_force" ]               && FORCE=$_opt_force
569 [ "$_opt_verbose" ]             && VERBOSE="-v"
570 [ "$_opt_debug" ]               && DEBUG="true"
571 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
572
573 # make sure main is always included
574 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
575 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
576 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
577
578 # command line option checks
579 if [ "$_opt_scripts_set" ] ; then
580   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
581   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
582 fi
583
584 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
585   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
586   eerror "The --grub option is unneeded as GRUB will be installed automatically."
587   eend 1
588   bailout 1
589 fi
590
591
592 if [ "$DEBUG" = "true" ] ; then
593   set -x
594 fi
595
596 [ "$_opt_help" ] && {
597   usage ; eend 0
598   eend 0
599   exit 0
600 }
601
602 [ "$_opt_version" ] && {
603   einfo "$PN - version $VERSION"
604   einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
605   eend 0
606   exit 0
607 }
608 # }}}
609
610 # check for root permissions {{{
611 if ! check4root ; then
612    echo "For usage instructions please execute '$PN --help'."
613    bailout 1
614 fi
615 # }}}
616
617 # make sure we have what we need {{{
618 if [ -n "$VIRTUAL" ] ; then
619   check4progs kpartx parted qemu-img || bailout 1
620 fi
621 # }}}
622
623 # source specified configuration file {{{
624 if [ -n "$CONFIGFILE" ] ; then
625   einfo "Reading specified config file $CONFIGFILE."
626   # shellcheck disable=SC1091 source=config
627   if ! . "$CONFIGFILE" ; then
628     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
629   fi
630 fi
631 # }}}
632
633 # backwards compatibility checks {{{
634 if [ -n "$GROOT" ] ; then
635    eerror "Error: you seem to have \$GROOT configured."
636    eerror "This variable is no longer supported, please visit the"
637    eerror "grml-debootstrap documentation for details."
638    eend 1
639    bailout 1
640 fi
641
642 if echo "$GRUB" | grep -q '^hd' ; then
643    eerror "Error: this syntax for the grub configuration variable is no longer supported."
644    eerror "Please do not use hd... any longer but /dev/sdX instead."
645    eend 1
646    bailout 1
647 fi
648 # }}}
649
650 # welcome screen {{{
651 welcome_dialog()
652 {
653    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
654 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
655 }
656 # }}}
657
658 # ask for target {{{
659 prompt_for_target()
660 {
661   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
662                sed 's/*//' | \
663                grep -v 'Extended$' | \
664                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
665
666   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
667      dialog --title "$PN" --trim \
668      --msgbox "Sorry, no partitions found. Please configure your
669      harddisks (see /proc/partitions) using a tool like fdisk,
670      cfdisk, gpart, gparted,..." 0 0
671      bailout 1
672   fi
673
674   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
675                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
676                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
677                      echo "$i" "$fs"
678                      unset fs
679                    done)
680
681   # shellcheck disable=SC2086
682   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
683          --menu "Please select the target partition:" 0 0 0 \
684          $PARTITION_LIST)
685   [ $? -eq 0 ] || bailout 1
686 }
687 # }}}
688
689 # ask for bootmanager {{{
690 prompt_for_bootmanager()
691 {
692   ADDITIONAL_PARAMS=""
693
694   if echo "$TARGET" | grep -q "/dev/md" ; then
695      MBRPART="all disks of Software RAID $TARGET"
696   else
697      # figure out whole disk device
698      found=
699      for device in /dev/disk/by-id/*
700      do
701         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
702         found=1
703         break
704      done
705      # shellcheck disable=SC2001
706      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
707      if [ -e "$MBRDISK" ]; then
708         MBRDISK=$(readlink -f "$MBRDISK")
709      else
710         # fall back to old behaviour
711         # shellcheck disable=SC2001
712         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
713      fi
714
715      MBRPART="MBR of $MBRDISK"
716   fi
717
718   for device in cciss/c0d0 sda hda; do
719     if [ "/dev/$device" != "${MBRDISK}" ]; then
720       grep -q $device /proc/partitions && \
721       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
722     fi
723   done
724   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
725
726   OIFS="$IFS"; IFS=:
727
728   # shellcheck disable=SC2086
729   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
730           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
731             mbr       "install bootmanager into $MBRPART" \
732             nowhere   "do not install bootmanager at all" \
733           ${ADDITIONAL_PARAMS})
734   [ $? -eq 0 ] || bailout 3
735   IFS="$OIFS"
736
737   case "$GETMBR" in
738     mbr)
739       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
740       if echo "$TARGET" | grep -q "/dev/md" ; then
741         GRUB="$TARGET"
742       else
743         GRUB="$MBRDISK"
744       fi
745       ;;
746     hda)
747       GRUB="/dev/hda"
748       ;;
749     sda)
750       GRUB="/dev/sda"
751       ;;
752     nowhere)
753       GRUB=''
754       ;;
755   esac
756 }
757 # }}}
758
759 # ask for Debian release {{{
760 prompt_for_release()
761 {
762   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='buster'
763   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
764             "Please enter the Debian release you would like to use for installation:" \
765             0 50 8 \
766             lenny    Debian/5.0 \
767             squeeze  Debian/6.0 \
768             wheezy   Debian/7.0 \
769             jessie   Debian/8.0 \
770             stretch  Debian/9.0 \
771             buster   Debian/10.0 \
772             bullseye Debian/11.0 \
773             sid      Debian/unstable)"
774   [ $? -eq 0 ] || bailout
775 }
776 # }}}
777
778 # ask for hostname {{{
779 prompt_for_hostname()
780 {
781   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
782             "Please enter the hostname you would like to use for installation:" \
783             0 0 "$HOSTNAME")"
784   [ $? -eq 0 ] || bailout
785 }
786 # }}}
787
788 # ask for password {{{
789 prompt_for_password()
790 {
791   if [ "$_opt_nopassword" ] ; then
792     einfo "Skip asking for root password as requested."
793     return 0
794   fi
795
796   ROOTPW1='PW1'
797   ROOTPW2='PW2'
798   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
799     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
800     "Please enter the password for the root account:" 10 60)
801     [ $? -eq 0 ] || bailout
802
803     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
804     "Please enter the password for the root account again for \
805     confirmation:" 10 60)
806     [ $? -eq 0 ] || bailout
807
808     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
809       dialog --stdout --title "${PN}" --ok-label \
810         "Retry" --msgbox "Passwords do not match!" 10 60
811     fi
812   done
813   ROOTPASSWORD="$ROOTPW1"
814 }
815 # }}}
816
817 # ask for Debian mirror {{{
818 prompt_for_mirror()
819 {
820   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
821
822   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
823           --menu "Where do you want to install from?" 0 0 0 \
824             net   "install via network (downloading from mirror)" \
825             local "install from local directory/mirror"
826           )
827   [ $? -eq 0 ] || bailout
828
829   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
830      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
831      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
832                "Please enter Debian mirror you would like to use for installing packages." \
833                0 0 $MIRROR)"
834      [ $? -eq 0 ] || bailout
835   else # CHOOSE_MIRROR == local
836      [ -n "$ISO" ] || ISO='/mnt/mirror'
837      ISO="$(dialog --stdout --title "${PN}" --inputbox \
838                "Please enter directory name you would like to use for installing packages." \
839                0 0 $ISO)"
840      [ $? -eq 0 ] || bailout
841   fi
842 }
843 # }}}
844
845 # software raid setup {{{
846 config_swraid_setup()
847 {
848 TMPFILE=$(mktemp)
849
850 # Currently we support only raid1:
851 RAIDLEVEL='raid1'
852
853 MD_LIST=$(for i in $(seq 0 9) ; do
854             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
855             echo "/dev/md$i /dev/md$i"
856           done)
857
858 # shellcheck disable=SC2086
859 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
860 --menu "Which device do you want to use for ${RAIDLEVEL}?
861
862 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
863 $MD_LIST)
864 [ $? -eq 0 ] || bailout 20
865
866 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
867              sed 's/*//' | \
868              grep -v 'Extended$' | \
869              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
870 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
871 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
872                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
873                  done)
874
875 # shellcheck disable=SC2086
876 dialog --title "$PN" --separate-output \
877        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
878        $PARTITION_LIST 2>"$TMPFILE"
879 [ $? -eq 0 ] || bailout
880 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
881
882 NUM_PARTITIONS=0
883 while IFS= read -r i; do
884   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
885 done < "$TMPFILE"
886
887 # force metadata version 0.90 for lenny so old grub can boot from this array.
888 METADATA_VERSION=""
889 if [ "$RELEASE" = "lenny" ]; then
890    METADATA_VERSION="-e0"
891 fi
892
893 ERRORFILE=$(mktemp)
894 # shellcheck disable=SC2086
895 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
896       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
897 RC=$?
898 if [ "$RC" = 0 ] ; then
899    dialog --title "$PN" --msgbox \
900    "Creating $TARGET was successful." 0 0
901    rm -f "$TMPFILE" "$ERRORFILE"
902 else
903    dialog --title "$PN" --msgbox \
904    "There was an error setting up $TARGET:
905
906 $(cat "$ERRORFILE")
907
908 Exiting." 0 0
909    rm -f "$TMPFILE" "$ERRORFILE"
910    bailout 1
911 fi
912
913 }
914
915 prompt_for_swraid()
916 {
917 if dialog --stdout --title "$PN" \
918           --defaultno --yesno "Do you want to configure Software RAID?
919
920 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
921   config_swraid_setup
922 fi
923 }
924 # }}}
925
926 # user should recheck his configuration {{{
927 # support full automatic installation:
928 checkforrun() {
929    dialog --timeout 10 --title "$PN" \
930           --yesno "Do you want to stop at this stage?
931
932 Notice: you are running ${PN} in non-interactive mode.
933 ${PN} will install Debian ${RELEASE} on ${TARGET}.
934 Last chance to quit. Timeout of 10 seconds running....
935
936 Do you want to stop now?" 0 0 2>/dev/null
937 }
938 # }}}
939
940 # format efi partition {{{
941 format_efi_partition() {
942   if [ -z "$EFI" ] ; then
943     return 0
944   fi
945
946   if ! [ -b "$EFI" ] ; then
947     eerror "Specified efi argument [$EFI] not a valid block device."
948     bailout 1
949   fi
950
951   if fsck.vfat -bn "$EFI" >/dev/null; then
952     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying." ; eend 0
953   else
954     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
955     mkfs.fat -F32 -n "EFI System Partition" "$EFI"
956     RC=$?
957     if [ $RC -eq 0 ] ; then
958       eend 0
959     else
960       eerror "Error while creating filesystem on ${EFI}."
961       eend 1
962       bailout 1
963     fi
964   fi
965 }
966 # }}}
967
968 # check for EFI support or try to enable it {{{
969 efi_support() {
970   if lsmod | grep -q efivars ; then
971     einfo "EFI support detected." ; eend 0
972     return 0
973   fi
974
975   if modprobe efivars &>/dev/null ; then
976     einfo "EFI support enabled now." ; eend 0
977     return 0
978   fi
979
980   return 1
981 }
982 # }}}
983
984 # make sure the user is aware of the used configuration {{{
985 checkconfiguration()
986 {
987
988 if efi_support ; then
989   if [ -z "$_opt_efi" ] ; then
990     ewarn "EFI support detected but no --efi option given, please consider enabling it." ; eend 0
991   fi
992 else
993   if [ -n "$_opt_efi" ] ; then
994      eerror "EFI option used but no EFI support detected." ; eend 0
995      bailout 1
996   fi
997 fi
998
999 if [ -n "$AUTOINSTALL" ] ; then
1000    if checkforrun ; then
1001       eerror "Exiting as requested" ; eend 0
1002       bailout 1
1003    fi
1004 elif [ -n "$INTERACTIVE" ] ; then
1005
1006    INFOTEXT="Please recheck configuration before execution:
1007    "
1008    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1009    Target:          $TARGET"
1010    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1011    Install grub:    $GRUB"
1012    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1013    Install efi:     $EFI"
1014    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1015    Using release:   $RELEASE"
1016    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1017    Using hostname:  $HOSTNAME"
1018    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1019    Using mirror:    $MIRROR"
1020    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1021    Using ISO:       $ISO"
1022    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1023    Using arch:      $ARCH"
1024    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1025    Config files:    $CONFFILES"
1026
1027    INFOTEXT="$INFOTEXT
1028
1029 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1030
1031    dialog --title "$PN" --no-collapse \
1032           --yesno "$INFOTEXT" 0 0
1033    [ $? -eq 0 ] || bailout 0
1034
1035 else # if not running automatic installation display configuration and prompt for execution:
1036    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1037    echo
1038    echo "   Target:          $TARGET"
1039
1040    # do not display if MNTPOINT is the default one
1041    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1042
1043    if [ -n "$VIRTUAL" ] ; then
1044       echo "   Install grub:    yes"
1045    else
1046      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1047      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1048    fi
1049
1050    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1051    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1052    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1053    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1054    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1055    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1056    if [ -n "$VIRTUAL" ] ; then
1057       echo "   Deploying as Virtual Machine."
1058       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1059          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1060       fi
1061    fi
1062
1063    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1064       echo
1065       echo "   You do not have a TTY allocated, your password will be shown in"
1066       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1067    fi
1068
1069    echo
1070    echo "   Important! Continuing will delete all data from ${TARGET}!"
1071
1072    if [ -n "$FORCE" ] ; then
1073      einfo "Skip user acknowledgement as requested via --force option."
1074    else
1075      echo
1076      einfon "Is this ok for you? [y/N] "
1077      read -r a
1078      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1079         eerror "Exiting as requested." ; eend 1
1080         bailout 1
1081      fi
1082    fi
1083 fi
1084 }
1085 # }}}
1086
1087 # interactive mode {{{
1088 interactive_mode()
1089 {
1090   check4progs dialog || bailout 1
1091
1092   welcome_dialog
1093
1094   prompt_for_release
1095
1096   prompt_for_swraid
1097
1098   prompt_for_target
1099
1100   prompt_for_bootmanager
1101
1102   prompt_for_hostname
1103
1104   prompt_for_password
1105
1106   prompt_for_mirror
1107 }
1108
1109 # run interactive mode if we didn't get the according configuration yet
1110 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1111    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1112    INTERACTIVE=1
1113    interactive_mode
1114 fi
1115 # }}}
1116
1117 # architecture setup {{{
1118 if [ -n "$ARCH" ] ; then
1119    ARCHCMD="--arch $ARCH"
1120    ARCHINFO=" (${ARCH})"
1121 else
1122    ARCH="$(dpkg --print-architecture)"
1123    ARCHCMD="--arch $ARCH"
1124    ARCHINFO=" (${ARCH})"
1125 fi
1126 # }}}
1127
1128 # It is not possible to build amd64 on i686. {{{
1129 CURRENT_ARCH="$(uname -m)"
1130 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1131    if [ "$ARCH" = "amd64" ] ; then
1132       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1133       bailout 1
1134    fi
1135 fi
1136 # }}}
1137
1138 # Support for generic release codenames is unavailable. {{{
1139 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1140    eerror "Generic release codenames (stable, testing) are unsupported. \
1141 Please use specific codenames such as stretch or buster." ; eend 1
1142    bailout 1
1143 fi
1144 # }}}
1145
1146 checkconfiguration
1147
1148 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1149 if [ -n "$TARGET" ] ; then
1150    SHORT_TARGET="${TARGET##*/}"
1151 else
1152    eerror "Please adjust $CONFFILES/config or..."
1153    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1154    bailout 1
1155 fi
1156 # }}}
1157
1158 # stages setup {{{
1159 if [ -z "$STAGES" ] ; then
1160    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1161    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1162 fi
1163
1164 if [ -r "$STAGES"/grml-debootstrap ] ; then
1165    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1166       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1167       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1168    fi
1169 fi
1170 # }}}
1171
1172 # partition handling {{{
1173 PARTITION=''
1174 DIRECTORY=''
1175
1176 set_target_directory(){
1177     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1178     DIRECTORY=1
1179     MNTPOINT="$TARGET"
1180     MKFS=''
1181     TUNE2FS=''
1182     FSCK=''
1183     # make sure we normalise the path to an absolute directory name so something like:
1184     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1185     # works
1186     TARGET="$(readlink -f "$TARGET")"
1187 }
1188
1189 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1190     PARTITION=1
1191 else
1192     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1193     if [[ $TARGET == "/dev/"* ]]; then
1194       eerror "Error: Will not create target directory $TARGET in /dev."
1195       eerror "  Please check the partition(s) of the blockdevice."; eend 1
1196       bailout 1
1197     fi
1198     set_target_directory
1199 fi
1200 # }}}
1201
1202 # make sure we have the right syntax when using an iso image {{{
1203 if [ -n "$ISO" ] ; then
1204    case $ISO in
1205       file*) # do nothing
1206       ;;
1207       *)
1208       ISO=file:$ISO
1209       ;;
1210    esac
1211 fi
1212 ISODIR=${ISO##file:}
1213 ISODIR=${ISODIR%%/}
1214 # }}}
1215
1216 # Debian ISOs do not contain signed Release files {{{
1217 if [ -n "$ISO" ] ; then
1218     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1219 fi
1220 # }}}
1221
1222 # create filesystem {{{
1223 mkfs() {
1224   if [ -n "$DIRECTORY" ] ; then
1225      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1226      return 0
1227   fi
1228
1229   if grep -q "$TARGET" /proc/mounts ; then
1230     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1231     bailout 1
1232   fi
1233
1234   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1235   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1236   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1237     case "$MKFS" in
1238       mkfs.ext*)
1239         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1240         MKFS_OPTS="$MKFS_OPTS -F"
1241         eend 0
1242
1243         ;;
1244     esac
1245   fi
1246
1247   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1248   # by default, which requires a recent version of tune2fs on the target system then,
1249   # so disable this feature for older Debian releases where it's known to be unsupported
1250   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1251     case "$RELEASE" in
1252       lenny|squeeze|wheezy|jessie)
1253         # assume a more recent version if we can't identify the version via dpkg-query
1254         local e2fsprogs_version
1255         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1256         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1257           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1258           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1259           eend 0
1260         fi
1261         ;;
1262     esac
1263   fi
1264
1265   if [ -n "$MKFS" ] ; then
1266     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1267     # shellcheck disable=SC2086
1268     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1269
1270     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1271       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1272         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1273         eend 1
1274         bailout 1
1275       else
1276         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1277         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
1278         eend $?
1279       fi
1280     fi
1281
1282     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1283     # will fail to detect the uuid in the chroot
1284     if [ -n "$VIRTUAL" ] ; then
1285       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1286     elif echo "$TARGET" | grep -q "/dev/md" ; then
1287       blockdev --rereadpt "${TARGET}"
1288     else
1289       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1290       local main_device="${TARGET%%[0-9]*}"
1291       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1292       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1293         blockdev --rereadpt "$main_device"
1294       else
1295         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1296       fi
1297     fi
1298     # give the system 2 seconds, otherwise we might run into
1299     # race conditions :-/
1300     sleep 2
1301
1302     eend $RC
1303   fi
1304 }
1305 # }}}
1306
1307 # retrieve ID_FS_UUID {{{
1308 identify_target_uuid() {
1309   local device="$1"
1310
1311   if ! [ -b "$device" ] ; then
1312     return 1
1313   fi
1314
1315   eval "$(blkid -o udev "$1" 2>/dev/null)"
1316
1317   if [ -n "$ID_FS_UUID" ] ; then
1318     echo "$ID_FS_UUID"
1319   else
1320     return 1
1321   fi
1322 }
1323 # }}}
1324
1325 # identify TARGET_UUID {{{
1326 mountpoint_to_blockdevice() {
1327   TARGET_UUID=''
1328
1329   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1330   if [ -n "$TARGET_UUID" ] ; then
1331     einfo "Identified UUID $TARGET_UUID for $TARGET"
1332     return 0
1333   fi
1334
1335   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1336   for file in /sys/block/*/*/dev ; do
1337     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1338       local dev
1339       dev="${file%/dev}"
1340       dev="/dev/${dev##*/}"
1341       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1342
1343       if [ -n "$TARGET_UUID" ] ; then
1344         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1345         return 0
1346       fi
1347     fi
1348   done
1349 }
1350 # }}}
1351
1352 # modify filesystem settings {{{
1353 tunefs() {
1354   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1355      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1356      $TUNE2FS "$TARGET"
1357      eend $?
1358   fi
1359 }
1360 # }}}
1361
1362 # mount the new partition or if it's a directory do nothing at all {{{
1363 mount_target() {
1364   if [ -n "$DIRECTORY" ] ; then
1365      einfo "Running grml-debootstrap on a directory, nothing to mount."
1366   else
1367      if grep -q "$TARGET" /proc/mounts ; then
1368         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
1369      else
1370        if ! [ -d "${MNTPOINT}" ] ; then
1371           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1372        fi
1373        einfo "Mounting $TARGET to $MNTPOINT"
1374        mkdir -p "$MNTPOINT"
1375        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1376        eend $?
1377      fi
1378   fi
1379   if [ -n "$ISODIR" ] ; then
1380      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1381      mkdir -p "$MNTPOINT/$ISODIR"
1382      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1383      eend $?
1384   fi
1385 }
1386 # }}}
1387
1388 # prepare VM image for usage with debootstrap {{{
1389 prepare_vm() {
1390   if [ -z "$VIRTUAL" ] ; then
1391      return 0 # be quiet by intention
1392   fi
1393
1394   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1395      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1396      eend 1
1397      bailout 1
1398   fi
1399   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1400      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1401      eend 1
1402      bailout 1
1403   fi
1404
1405   # make sure loop module is present and a usable loop device exists
1406   modprobe -q loop
1407   if ! losetup -f >/dev/null 2>&1; then
1408     eerror "Error finding usable loop device" ; eend 1
1409     bailout 1
1410   fi
1411
1412   # if dm-mod isn't available then kpartx will fail with
1413   # "Is device-mapper driver missing from kernel? [...]"
1414   modprobe -q dm-mod
1415   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1416     eerror "Device-mapper support missing in kernel." ; eend 1
1417     bailout 1
1418   fi
1419
1420   ORIG_TARGET="$TARGET" # store for later reuse
1421
1422   if [ -n "$VMFILE" ]; then
1423     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1424   fi
1425   parted -s "${TARGET}" 'mklabel msdos'
1426   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1427     einfo "Adjusting disk signature to a fixed (non-random) value"
1428     MBRTMPFILE=$(mktemp)
1429     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1430     echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1431     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1432     eend $?
1433   fi
1434   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1435   parted -s "${TARGET}" 'set 1 boot on'
1436
1437   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3'
1438   if [ -z "${DEVINFO}" ] ; then
1439     eerror "Error setting up loopback device." ; eend 1
1440     bailout 1
1441   fi
1442
1443   # hopefully this always works as expected
1444   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1445   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1446   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1447   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1448
1449   if [ -z "$TARGET" ] ; then
1450      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1451      bailout 1
1452   fi
1453 }
1454 # }}}
1455
1456 # make VM image bootable {{{
1457 grub_install() {
1458   if [ -z "${VIRTUAL}" ] ; then
1459      return 0
1460   fi
1461   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1462     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1463     return 0
1464   fi
1465
1466   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1467     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1468     bailout 1
1469   fi
1470
1471   mount -t proc none "${MNTPOINT}"/proc
1472   mount -t sysfs none "${MNTPOINT}"/sys
1473   mount -t devtmpfs udev "${MNTPOINT}"/dev
1474   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1475
1476 # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1477 # chroot-script skips installation for unset ${GRUB}
1478 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1479   einfo "Installing Grub as bootloader."
1480
1481   if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1482     echo "Notice: grub-pc package not present yet, installing it therefore."
1483     # shellcheck disable=SC2086
1484     DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
1485   fi
1486
1487   mkdir -p "${MNTPOINT}/boot/grub"
1488   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1489      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1490      bailout 1
1491   fi
1492
1493   case "$RELEASE" in
1494     lenny|squeeze|wheezy)
1495       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1496       ;;
1497     *)
1498       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1499       ;;
1500   esac
1501   dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1502   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1503   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1504   rm -f "${MNTPOINT}/tmp/core.img"
1505 fi
1506
1507   einfo "Updating grub configuration file."
1508   if [ -n "$BOOT_APPEND" ] ; then
1509      sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
1510   fi
1511   chroot "${MNTPOINT}" update-grub
1512
1513   case "$RELEASE" in
1514     jessie)
1515       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1516       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1517       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1518       ;;
1519   esac
1520
1521   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1522     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1523     ewarn "Please note that your system might NOT be able to properly boot."
1524   else
1525     einfo "Adjusting grub.cfg for successful boot sequence."
1526     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1527   fi
1528
1529   umount "${MNTPOINT}"/proc
1530   umount "${MNTPOINT}"/sys
1531   umount "${MNTPOINT}"/dev/pts
1532   try_umount 3 "${MNTPOINT}"/dev
1533
1534 }
1535 # }}}
1536
1537 # unmount VM image {{{
1538 umount_target() {
1539   if [ -z "${VIRTUAL}" ] ; then
1540      return 0
1541   fi
1542
1543   umount "${MNTPOINT}"
1544   kpartx -d "${ORIG_TARGET}" >/dev/null
1545   # Workaround for a bug in kpartx which doesn't clean up properly,
1546   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1547   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1548     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1549   fi
1550 }
1551 # }}}
1552
1553 # install main chroot {{{
1554 debootstrap_system() {
1555   if [ "$_opt_nodebootstrap" ]; then
1556      einfo "Skipping debootstrap as requested."
1557      return
1558   fi
1559
1560   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1561     :
1562   else
1563     eerror "Error: $MNTPOINT not mounted, can not continue."
1564     eend 1 ; exit 1
1565   fi
1566
1567   if [ -n "$ISO" ] ; then
1568     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1569     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1570     # shellcheck disable=SC2086
1571     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1572     RC=$?
1573   else
1574     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1575     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1576     # shellcheck disable=SC2086
1577     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1578     RC=$?
1579   fi
1580
1581   if [ $RC -ne 0 ] ; then
1582     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1583       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1584       einfo "Presenting last ten lines of debootstrap.log:"
1585       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1586       einfo "End of debootstrap.log"
1587     fi
1588   fi
1589
1590   eend $RC
1591 }
1592 # }}}
1593
1594 # prepare chroot via chroot-script {{{
1595 preparechroot() {
1596   einfo "Preparing chroot system"
1597
1598   # provide variables to chroot system
1599   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1600   touch "$CHROOT_VARIABLES"
1601   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1602   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1603   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1604   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1605   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1606   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1607   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1608   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1609   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1610   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1611   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1612   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1613   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1614   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1615   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1616   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1617   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1618   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1619   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1620   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1621   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1622   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1623   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1624   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1625   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1626   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1627   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1628   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1629   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1630   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1631   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1632   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1633   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1634   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1635   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1636   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1637   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1638   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1639   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1640   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1641   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1642   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1643   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1644   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1645   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1646   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1647   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1648
1649   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1650   chmod 755 "${MNTPOINT}"/bin/chroot-script
1651   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1652
1653   # make sure we have our files for later use via chroot-script
1654   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1655   # make sure we adjust the configuration variables accordingly:
1656   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1657   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1658   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1659
1660   # install notes:
1661   if [ -n "$INSTALL_NOTES" ] ; then
1662      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1663   fi
1664
1665   # package selection:
1666   if [ "$PACKAGES" = 'yes' ] ; then
1667     cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1668       "${MNTPOINT}"/etc/debootstrap/packages
1669   fi
1670
1671   # debconf preseeding:
1672   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1673   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1674     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1675
1676   # copy scripts that should be executed inside the chroot:
1677   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1678   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1679     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1680     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1681   }
1682
1683   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1684   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1685
1686   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1687
1688   # make sure we can access network [relevant for cdebootstrap]
1689   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1690
1691   # setup default locales
1692   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1693
1694   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1695   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1696
1697   # copy any existing files to chroot
1698   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1699   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1700   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1701   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1702   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1703   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1704   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1705
1706   # network setup
1707   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1708
1709 # Include files from /etc/network/interfaces.d when using
1710 # ifupdown v0.7.44 or newer:
1711 #source-directory /etc/network/interfaces.d
1712
1713 auto lo
1714 iface lo inet loopback
1715
1716 allow-hotplug eth0
1717 iface eth0 inet dhcp
1718 "
1719
1720   if [ -n "$NOINTERFACES" ] ; then
1721     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1722   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1723     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1724     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1725     eend $?
1726   elif [ -n "$VIRTUAL" ] ; then
1727     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1728     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1729     eend $?
1730   elif [ -r /etc/network/interfaces ] ; then
1731     einfo "Copying /etc/network/interfaces from host to target system"
1732     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1733     eend $?
1734   else
1735     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1736     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1737     eend $?
1738   fi
1739
1740   # install config file providing some example entries
1741   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1742      cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1743   fi
1744
1745   if [ -d /run/udev ] ; then
1746     einfo "Setting up bind-mount /run/udev"
1747     mkdir -p "${MNTPOINT}"/run/udev
1748     mount --bind /run/udev "${MNTPOINT}"/run/udev
1749     eend $?
1750   fi
1751
1752   eend 0
1753 }
1754 # }}}
1755
1756 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1757 execute_pre_scripts() {
1758   # make sure hostname is set even before chroot-script get executed
1759   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1760
1761   # make sure we have $MNTPOINT available for our scripts
1762   export MNTPOINT
1763
1764   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1765     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1766     for script in "${pre_scripts}"/* ; do
1767       if [ -x "$script" ] ; then
1768         einfo "Executing pre-script $script"
1769         "$script" ; eend $?
1770       fi
1771     done
1772   fi
1773 }
1774 # }}}
1775
1776 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1777 execute_post_scripts() {
1778   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1779   export MNTPOINT
1780   export TARGET_HOSTNAME=$HOSTNAME
1781
1782   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1783     # legacy support for /etc/debootstrap/scripts/
1784     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
1785     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
1786   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
1787     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
1788   fi
1789
1790   if [ -n "$post_scripts" ] ; then
1791     for script in "${post_scripts}"/* ; do
1792       if [ -x "$script" ] ; then
1793         einfo "Executing post-script $script"
1794         "$script" ; eend $?
1795       fi
1796     done
1797   fi
1798 }
1799 # }}}
1800
1801 # unmount mountpoint {{{
1802 try_umount() {
1803   local tries=$1
1804   local mountpoint="$2"
1805
1806   for (( try=1; try<=tries; try++ )); do
1807     if [[ ${try} -eq ${tries} ]]; then
1808       # Last time, show errors this time
1809       umount "${mountpoint}" && return 0
1810     else
1811       # Not last time, hide errors until fatal
1812       if umount "${mountpoint}" 2>/dev/null ; then
1813         return 0
1814       else
1815         sleep 1
1816       fi
1817     fi
1818   done
1819   return 1  # Tried enough
1820 }
1821 # }}}
1822
1823 # execute chroot-script {{{
1824 chrootscript() {
1825   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1826     mount_target
1827   fi
1828
1829   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1830     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1831     eend 1
1832   else
1833     einfo "Executing chroot-script now"
1834     mount -t devtmpfs udev "${MNTPOINT}"/dev
1835     mount -t devpts devpts "${MNTPOINT}"/dev/pts
1836     if [ "$DEBUG" = "true" ] ; then
1837       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
1838     else
1839       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1840     fi
1841     try_umount 3 "$MNTPOINT"/dev/pts
1842     try_umount 3 "$MNTPOINT"/dev
1843     eend $RC
1844   fi
1845
1846   # finally get rid of chroot-script again, there's no good reason to
1847   # keep it on the installed system
1848   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1849     einfo "Removing chroot-script again"
1850     rm -f "${MNTPOINT}/bin/chroot-script"
1851     eend $?
1852   else
1853     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1854     eend 0
1855   fi
1856 }
1857 # }}}
1858
1859 # unmount $MNTPOINT {{{
1860 umount_chroot() {
1861
1862   # display installation notes:
1863   if [ -n "$INSTALL_NOTES" ] ; then
1864      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1865   fi
1866
1867   if [ -n "$ISODIR" ] ; then
1868      if grep -q "$ISODIR" /proc/mounts ; then
1869         einfo "Unmount $MNTPOINT/$ISODIR"
1870         umount "$MNTPOINT/$ISODIR"
1871         eend $?
1872      fi
1873   fi
1874
1875   if grep -q "$MNTPOINT" /proc/mounts ; then
1876     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1877       einfo "Unmounting bind-mount /run/udev"
1878       umount "${MNTPOINT}"/run/udev
1879       eend $?
1880     fi
1881
1882      if [ -n "$PARTITION" ] ; then
1883         einfo "Unmount $MNTPOINT"
1884         umount "$MNTPOINT"
1885         eend $?
1886      fi
1887   fi
1888 }
1889 # }}}
1890
1891 # execute filesystem check {{{
1892 fscktool() {
1893  if [ -n "$VIRTUAL" ] ; then
1894    einfo "Skipping filesystem check because we deploy a virtual machine."
1895    return 0
1896  fi
1897
1898  if [ "$FSCK" = 'yes' ] ; then
1899    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1900    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1901    "$FSCKTOOL" "$TARGET"
1902    eend $?
1903  fi
1904 }
1905 # }}}
1906
1907 # get rid of grml-debootstrap config files {{{
1908 remove_configs() {
1909   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
1910     return 0
1911   fi
1912
1913   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
1914     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
1915     return 0
1916   fi
1917
1918   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
1919   rm -rf "${MNTPOINT}"/etc/debootstrap/
1920   eend $?
1921 }
1922 # }}}
1923
1924 # now execute all the functions {{{
1925 for i in format_efi_partition prepare_vm mkfs tunefs \
1926          mount_target mountpoint_to_blockdevice debootstrap_system \
1927          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
1928          remove_configs umount_chroot grub_install umount_target fscktool ; do
1929     if stage "${i}" ; then
1930       if "$i" ; then
1931         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
1932       else
1933         bailout 2 "$i"
1934       fi
1935     fi
1936 done
1937
1938 cleanup
1939 # }}}
1940
1941 # end dialog of autoinstallation {{{
1942 if [ -n "$AUTOINSTALL" ] ; then
1943    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
1944 Automatically rebooting in 10 seconds.
1945
1946 Choose Cancel to skip rebooting." 10 60 10 ; then
1947      noeject noprompt reboot
1948   fi
1949 else
1950    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
1951 fi
1952 # }}}
1953
1954 ## END OF FILE #################################################################
1955 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2